#!/usr/bin/perl
#
$WEBDIR = "/usr/local/www";
$CGIDIR = "$WEBDIR/cgi-bin";
$TMPLDIR= "/usr/local/monitor/templates";
$STATSAF= "/tmp/stats.access";

        push(@INC, "$CGIDIR");
        require 'mon-lib.pl';

	&GetIpsInfo();
        if ($IPSDEVTYPE eq "controller") { 
	    &PrintButtonBar("HEADER", "Flow Statistics"); 
	} elsif ($IPSDEVTYPE eq "gateway") {
		&PrintButtonBar("HEADER", "No Flow View Available"); 
        	&PrintButtonBar("TRAILER");
		return;
	} else {
	    &PrintButtonBar("HEADER", "Flow Statistics");  # BOGUS @@
	}
	&form(); &PrintButtonBar("TRAILER");

        open(SF, ">$STATSAF");   # Touch the stats file
        print SF " ";
        close(SF);
        open(SF, "$STATSAF");   
        $trash= <SF>;
        close(SF);

        &procstart();


sub get {
  local($thing) = @_;
  open (FD, "/usr/local/config/bin/dbget $thing |");
  $result=<FD>;
  close(FD);
  chop($result);
  return($result);
}

sub procstart {
  system("/usr/local/config/bin/udw machine:$machine:process:poll.pl t");
  return(1);
}


sub GetIpsInfo {
  $machine=&get("machine");
  
  $IPSDEVTYPE=&get("machine:${machine}:type"); 
  local($_);
}

sub form {

	local($start) = 0;
	($counts) = 0;
	local($tmpl) = "$TMPLDIR/flows.tmpl";
	local($s);
	local($lineNum) = 1;
	local($countNum);
	local($_);

	dbmopen(%flow_stats, '/usr/local/monitor/data/flow_stats', 0666);
	$countNum = $flow_stats{"interval.countNum"};
	if (++$countNum > 12 || $flow_stats{"interval.$countNum.total_cells"} eq "")
		{ $countNum = 1; }

	if(!open(READTMPL, $tmpl))
		{ &PrintMsgHdr("Can't open $tmpl: $!"); return 1; }
	while (<READTMPL>) {
                if (/START/)
			{ $start = 1; next; }
		if (/END/)
			{ $start = 0; next; }
		if ($start) 
			{ $count_tmpl{$lineNum++} = $_; next; }
		# Replace IP Switch name
		if (/\@ipswitch\@/)
			{ $s= &IpswitchName; s/\@ipswitch\@/$s/; }
		if (/COUNT/) {
			while (++$counts < 13) {
				$lineNum = 1;
				while ($count_tmpl{$lineNum}) {
					$_ = $count_tmpl{$lineNum++};
					if (/\@(\S*)\@/)
						{ $_= &MapTempVal($1,$_,$countNum); }
					print "$_";
				}
				if (++$countNum > 12)
					{ $countNum = 1; }
			}
		}
		print "$_";
	}
	close(READTMPL);
	dbmclose(flow_stats);
}

sub MapTempVal {
local($mSub,$line,$index) = @_; 
local($s) = &$mSub($index);

	$line =~ s/\@$mSub\@/$s/; return $line; 
}

sub GetInterval {
	return $counts;
}

sub GetSwitchedCells {
local($count) = @_;
	return $flow_stats{"interval.$count.switched.cells"};
}

sub GetSwitchedBytes {
local($count) = @_;
	return $flow_stats{"interval.$count.switched.bytes"};
}

sub GetSwitchedPC {
local($count) = @_;
	return $flow_stats{"interval.$count.switched.percent"};
}

sub GetForwardedCells {
local($count) = @_;
	return $flow_stats{"interval.$count.forwarded.cells"};
}

sub GetForwardedBytes {
local($count) = @_;
	return $flow_stats{"interval.$count.forwarded.bytes"};
}

sub GetForwardedPC {
local($count) = @_;
	return $flow_stats{"interval.$count.forwarded.percent"};
}

