#!/usr/bin/perl
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################

$WEBDIR = "/usr/local/www";
$CGIDIR = "$WEBDIR/cgi-bin";

#
# This file creates the live switch display
#
####### BEGIN MAIN ########
        push(@INC, "$CGIDIR");
        require 'mon-lib.pl';
        require "flush.pl";

	$hostname = &IpswitchName();

        # Print out header
        &PrintButtonBar("HEADER", "Routing Table: $hostname");

	# Print out form
	&netstat("rn");

        # Print out trailer
	print "<hr size=4>";
        &PrintButtonBar("TRAILER");
####### END MAIN ########


sub netstat {
    local($option) = @_;

    open (FD, "/usr/bin/netstat -$option |");

    print "<pre>\n";
    while (<FD>) {
	if(/Routing/) { s/Routing/<b>Routing/; } 
	if(/Expire/) { s/Expire/  Expire<\/b>/; }
	print "$_\n";
    }
    print "</pre>\n";
    close(FD);
}

