#!/usr/bin/perl

# Globals

    push(@INC, "/usr/local/www/cgi-bin");
    require 'qos-lib.pl';

    &ReadInput(*INPUT);
    &ParseData(*GLOBAL, $INPUT);
    &set_var;
    &display_help;

    &display_curr_flow;
#print "End : ", &ctime(time), "<br>\n";
    &PrintHeadToe("TRAILER", "", 
	"/conf/conf_view_qos2.html", 
	"/cgi-bin/new_policy.pl",
	"/cgi-bin/qos.pl?IHelp=$nhelp",
	"/cgi-bin/html_page?TEMPLATE=main");

########################################################

sub display_help {
    if ($ihelp eq "on") {
	print "<img src=\"/images/config/helpbar.gif\"><br>";
	print "<font -= 2>\n";
	print "Rules for the currently selected policy are being displayed in the rule list.  There are four editing functions for the rules: Copy, Create, Delete and Edit.  Select a rule from the rule list and click on one of these editing functions.  Copy rule will copy all attributes from the selected rule to the new rule.<br><br>\n";
	print "Matching are processed in strict Top-to-bottom fashion.  Therefore,  it is very important to make sure the rules are configured in the order desired.  In general, more specific rules should be configured before less specific reles.  If you need to re-order the rules, select the Move function.<br>\n";
	print "<img src=\"/images/config/bar.gif\"><br>";
    }
}

sub display_curr_flow {
    print "<br>\n";
    print "<center>\n";
    if ($PlistSize) {
	print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/change_rule.pl?\">";
	print "<h3><b>Rules for Policy: <i>$mastertable</b></i></h3>\n";
#	print "<center><table><tr>\n";
#	print "<td align=right><h4>Policy Rules: </h4>";
#	print "<td align=left>\n";
	print "<center>\n";
	&disp_rules("", 0, 1);
#	print "</tr></table>\n";
	print "<br>\n";
	print "<h4>\n";
	print "Rule Editing: \n";
	print "<INPUT TYPE=\"submit\" NAME=\"FlowEdit\" VALUE=\"Copy\">\n";
	print "<INPUT TYPE=\"submit\" NAME=\"FlowEdit\" VALUE=\"Create\">\n";
	print "<INPUT TYPE=\"submit\" NAME=\"FlowEdit\" VALUE=\"Delete\">\n";
	print "<INPUT TYPE=\"submit\" NAME=\"FlowEdit\" VALUE=\"Edit\">\n";
	print "<INPUT TYPE=\"submit\" NAME=\"FlowEdit\" VALUE=\"Move\">\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"PListSize\" VALUE=\"$PlistSize\">\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"TableSelect\" VALUE=\"$mastertable\">\n";
	print "</h4></FORM>\n\n";

	print "<h4><b>Optional: ";
	print "<a href=\"/cgi-bin/forward.pl\"> Forwarding Rules</a>\n";
	print "</center>\n";
	print "<br>\n";
    }
    else {
	if ($mastertable && !$selectpolicy) {
	    print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/change_rule.pl\">";
	    print "<h3><b>Current Policy: <i>$mastertable</b></i></h3>\n";

	    print "<h4>\n";
	    print "There is no rule defined for \"$mastertable\".<br>\n";
	    print "Press \"Create Rule\" to create new rules,<br>\n";
	    print "or \"Select\" to select other policy.<br>\n";
	    print "</h4>\n";
	    print "<table><tr>\n";
	    print "<td><h5><INPUT TYPE=\"hidden\" NAME=\"FlowEdit\" VALUE=\"Create\"></h5>\n";
	    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Junk\" VALUE=\"Create Rule\"></h5>\n";
	    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Select\"></h5>\n";
	    print "</tr></table>\n";
	    print "<INPUT TYPE=\"hidden\" NAME=\"PListSize\" VALUE=\"$PlistSize\">\n";
	    print "</FORM>";
	    print "</center>\n";
	}
	else {
	    print "<center>\n";
	    print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/new_policy.pl\">\n";
	    print "<br><br>\n";
	    print "There is no service policy defined.  Do you wish to create one now?\n";
	    print "<br>";
	    print "<h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Create\"></h5>\n";
	    print "</FORM>\n";
	}
    }
}


sub set_var {
    $ihelp = $GLOBAL{'IHelp'};
    if (!$ihelp) {
	$ihelp = "off";
	$nhelp = "on";
    }
    elsif ($ihelp eq "on") {
	$nhelp = "off";
    }
    else {
	$nhelp = "on";
    }

    &PrintHeadToe("HEADER",
        "Policy Rule Editing",
        "/conf/conf_view_qos2.html",
        "/cgi-bin/new_policy.pl",
        "/cgi-bin/qos.pl?&IHelp=$nhelp",
        "/cgi-bin/html_page?TEMPLATE=main");

#print "Start: ", &ctime(time), "<br>\n";
    $action = $GLOBAL{'Action'};

    $selectpolicy = $GLOBAL{'SelectPolicy'};
    $deleterule = $selectpolicy;
    $save = $GLOBAL{'Save'};
#print "mastertable=$mastertable. selectpolicy=$selectpolicy. currorder=$currorder.<br>";

    #
    # if nothing is passed in, then this must be the first time it's called.
    # Go parse the database for existing policies and rules
    #
    if (!$mastertable || !$selectpolicy || !$currorder) {
	&get_new_policies;
    }
    &GetCurrentPolicy;
    &get_clist;

    $settable = $GLOBAL{'SetTable'};
    $newtable = $GLOBAL{'TableSelect'};
    if ($settable eq "Select") {
	$mastertable = $newtable;
    }

    if ($action eq "Delete" && $deleterule) {
      $policy_order = &GetPolicyOrder("$mastertable", "$deleterule");
      if ($policy_order) {
        $class = &GetPolicyValue("machine:$mname:policy:qostable:$mastertable:$policy_order:class");

	$selectpolicy = "";
	$currorder = "";

	if ($deleterule eq "selectpolicy") {
	    $n = "\n\nmachine:$mname:policy:qostable:control:default:name\n";
	    $newlines = $n;
	}
	else {
	    $newlines = "\n\n";
	}

	$newlines="machine:$mname:policy:qostable:$mastertable:$policy_order\n\nmachine:$mname:policy:qostable:$mastertable:$policy_order:name\n\nmachine:$mname:policy:qostable:$mastertable:$policy_order:class\n\nmachine:$mname:policy:qostable:$mastertable:$policy_order:swt\n\nmachine:$mname:policy:qostable:$mastertable:$policy_order:fo\n\nmachine:$mname:policy:qostable:$mastertable:$policy_order:filter\n\nmachine:$mname:policy:qostable:$mastertable:$policy_order:priority\n\nmachine:$mname:policy:class:$class:interface\n\nmachine:$mname:policy:class:$class:inbound\n\nmachine:$mname:policy:class:$class:outbound\n\nmachine:$mname:policy:class:$class:dst\n\nmachine:$mname:policy:class:$class:src\n\nmachine:$mname:policy:class:$class:ipproto\n\nmachine:$mname:policy:class:$class:srcport\n\nmachine:$mname:policy:class:$class:dstport\napply apply\n";

	&update_conf($newlines, 1);

	&get_new_policies;
	&GetCurrentPolicy;
      }
    }

    &get_rules_from_current_policy;
    if (!$selectpolicy || !$currorder) {
        $selectpolicy = $PNAMELIST[0];
        $currorder = $PLIST[0];
	if ($selectpolicy) {
	  &update_conf("\n\nmachine:$mname:policy:qostable:control:edit:rule $selectpolicy\napply apply\n", 0);
	}
    }
}
