if (!defined &_SYS_TIMEX_H_) {
    eval 'sub _SYS_TIMEX_H_ {1;}';
    if (!defined &MSDOS) {
	require 'sys/syscall.ph';
    }
    eval 'sub SHIFT_HZ {7;}';
    eval 'sub SHIFT_KG {6;}';
    eval 'sub SHIFT_KF {16;}';
    eval 'sub MAXTC {6;}';
    eval 'sub SHIFT_SCALE {23;}';
    eval 'sub SHIFT_UPDATE {(defined &SHIFT_KG && &SHIFT_KG + defined &MAXTC && &MAXTC);}';
    eval 'sub SHIFT_USEC {16;}';
    eval 'sub FINEUSEC {(1defined &L && &L << defined &SHIFT_SCALE && &SHIFT_SCALE);}';
    eval 'sub MAXPHASE {128000defined &L && &L;}';
    if (defined &PPS_SYNC) {
	eval 'sub MAXFREQ {(100defined &L && &L << defined &SHIFT_USEC && &SHIFT_USEC);}';
	eval 'sub MAXTIME {(200defined &L && &L << defined &PPS_AVG && &PPS_AVG);}';
    }
    else {
	eval 'sub MAXFREQ {(200defined &L && &L << defined &SHIFT_USEC && &SHIFT_USEC);}';
    }
    eval 'sub MINSEC {16defined &L && &L;}';
    eval 'sub MAXSEC {1200defined &L && &L;}';
    if (defined &PPS_SYNC) {
	eval 'sub PPS_AVG {2;}';
	eval 'sub PPS_SHIFT {2;}';
	eval 'sub PPS_SHIFTMAX {8;}';
	eval 'sub PPS_VALID {120;}';
	eval 'sub MAXGLITCH {30;}';
    }
    eval 'sub MOD_OFFSET {0x0001;}';
    eval 'sub MOD_FREQUENCY {0x0002;}';
    eval 'sub MOD_MAXERROR {0x0004;}';
    eval 'sub MOD_ESTERROR {0x0008;}';
    eval 'sub MOD_STATUS {0x0010;}';
    eval 'sub MOD_TIMECONST {0x0020;}';
    eval 'sub MOD_CLKB {0x4000;}';
    eval 'sub MOD_CLKA {0x8000;}';
    eval 'sub STA_PLL {0x0001;}';
    eval 'sub STA_PPSFREQ {0x0002;}';
    eval 'sub STA_PPSTIME {0x0004;}';
    eval 'sub STA_INS {0x0010;}';
    eval 'sub STA_DEL {0x0020;}';
    eval 'sub STA_UNSYNC {0x0040;}';
    eval 'sub STA_PPSSIGNAL {0x0100;}';
    eval 'sub STA_PPSJITTER {0x0200;}';
    eval 'sub STA_PPSWANDER {0x0400;}';
    eval 'sub STA_PPSERROR {0x0800;}';
    eval 'sub STA_CLOCKERR {0x1000;}';
    eval 'sub STA_RONLY {(defined &STA_PPSSIGNAL && &STA_PPSSIGNAL | defined &STA_PPSJITTER && &STA_PPSJITTER | defined &STA_PPSWANDER && &STA_PPSWANDER | defined &STA_PPSERROR && &STA_PPSERROR | defined &STA_CLOCKERR && &STA_CLOCKERR);}';
    eval 'sub TIME_OK {0;}';
    eval 'sub TIME_INS {1;}';
    eval 'sub TIME_DEL {2;}';
    eval 'sub TIME_OOP {3;}';
    eval 'sub TIME_WAIT {4;}';
    eval 'sub TIME_ERROR {5;}';
    if (defined &__FreeBSD__) {
	eval 'sub NTP_PLL_GETTIME {1;}';
	eval 'sub NTP_PLL_MAXID {2;}';
	eval 'sub NTP_PLL_NAMES {{ { 0, 0 }, { "gettime", defined &CTLTYPE_STRUCT && &CTLTYPE_STRUCT }, };}';
	if (!defined &KERNEL) {
	    require 'sys/cdefs.ph';
	}
    }
}
1;
