#!/usr/bin/perl
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################

$WEBDIR = "/usr/local/www";
$CGIDIR = "$WEBDIR/cgi-bin";

#
# This file creates the live switch display
#
####### BEGIN MAIN ########
        push(@INC, "$CGIDIR");
        require 'mon-lib.pl';

	$hostname = &IpswitchName();

        # Print out header
        &PrintButtonBar("HEADER", "Interface Configuration: $hostname");

	# Print out form
	&ifconfig();

        # Print out trailer
	print "<hr size=4>";
        &PrintButtonBar("TRAILER");
####### END MAIN ########


sub ifconfig {

    open (FD, "/sbin/ifconfig -a |");

    print "<pre>\n";
    while (<FD>) {
	chop;
	if(/</) { s/</ &lt/; }
	if(/>/) { s/>/&gt/; }

	if(/inet/ || /ether/) { 
		print "$_\n"
	}
	else {
		if(/flags/) { s/flags=/<br>   flags = /; }
		if(/mtu/) { s/mtu/<br>   mtu   =/; }
		print "\n<p>$_</p>\n";
	}
    }
    print "</pre>\n";
    close(FD);
}

