#!/usr/bin/perl
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################
#
$WEBDIR         = "/usr/local/www";
$CGIDIR         = "$WEBDIR/cgi-bin";
#
push(@INC, "$CGIDIR");
require 'mon-lib.pl';
require 'info-lib.pl';
require 'sysctl-lib.pl';
#
require 'systemStatus-lib.pl';
require 'systemDirects-lib.pl';
#
require 'util-lib.pl';
require 'layout-lib.pl';
require 'canvas-lib.pl';

# Collect sysctl info
#
&GetIpsInfo;
&GetTypeSpecific;

# Generate system status file
#
&genSystemStatus(*ips_data, *nic_data, *chassis);

# Generate system GIF file commands
#
&genSystemDirects();

# Generate system GIF file commands
#
system("/usr/local/bin/mkGif");

#Display system GIF
#
&PrintButtonBar("HEADER", "System View");
print "<table><tr><td align=center><img src=/images/mon/system.gif></td></tr></table>";
&PrintButtonBar("TRAILER");

