#!/usr/bin/perl
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################

$WEBDIR = "/usr/local/www";
$SYSCTLDIR = "$WEBDIR";
$CGIDIR = "$WEBDIR/cgi-bin";

#
# This file creates the live switch display
#
####### BEGIN MAIN ########
        push(@INC, "$CGIDIR");
        require 'mon-lib.pl';

        # Print out header
        &PrintButtonBar("HEADER", "Event Log File");

	# Print out form
	&form();

        # Print out trailer
        &PrintButtonBar("TRAILER");
####### END MAIN ########


sub form {
  local($trapfile) = "/var/log/messages";

    if (-e $trapfile) {
	    if(!open(READLOG, $trapfile)) {
		&PrintMsgHdr("Can't open $trapfile: $!");
		return 1;		
	    }

	    while (<READLOG>) {
		chop;

		print "$_<br>\n";
	    }
    }
    else {
	&PrintMsg("Cannot find event file: $trapfile");
    }
}

