if (!defined &_SYS_ERRNO_H_) {
    eval 'sub _SYS_ERRNO_H_ {1;}';
    if (!defined &KERNEL) {
    }
    eval 'sub EPERM {1;}';
    eval 'sub ENOENT {2;}';
    eval 'sub ESRCH {3;}';
    eval 'sub EINTR {4;}';
    eval 'sub EIO {5;}';
    eval 'sub ENXIO {6;}';
    eval 'sub E2BIG {7;}';
    eval 'sub ENOEXEC {8;}';
    eval 'sub EBADF {9;}';
    eval 'sub ECHILD {10;}';
    eval 'sub EDEADLK {11;}';
    eval 'sub ENOMEM {12;}';
    eval 'sub EACCES {13;}';
    eval 'sub EFAULT {14;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub ENOTBLK {15;}';
    }
    eval 'sub EBUSY {16;}';
    eval 'sub EEXIST {17;}';
    eval 'sub EXDEV {18;}';
    eval 'sub ENODEV {19;}';
    eval 'sub ENOTDIR {20;}';
    eval 'sub EISDIR {21;}';
    eval 'sub EINVAL {22;}';
    eval 'sub ENFILE {23;}';
    eval 'sub EMFILE {24;}';
    eval 'sub ENOTTY {25;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub ETXTBSY {26;}';
    }
    eval 'sub EFBIG {27;}';
    eval 'sub ENOSPC {28;}';
    eval 'sub ESPIPE {29;}';
    eval 'sub EROFS {30;}';
    eval 'sub EMLINK {31;}';
    eval 'sub EPIPE {32;}';
    eval 'sub EDOM {33;}';
    eval 'sub ERANGE {34;}';
    eval 'sub EAGAIN {35;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub EWOULDBLOCK {defined &EAGAIN && &EAGAIN;}';
	eval 'sub EINPROGRESS {36;}';
	eval 'sub EALREADY {37;}';
	eval 'sub ENOTSOCK {38;}';
	eval 'sub EDESTADDRREQ {39;}';
	eval 'sub EMSGSIZE {40;}';
	eval 'sub EPROTOTYPE {41;}';
	eval 'sub ENOPROTOOPT {42;}';
	eval 'sub EPROTONOSUPPORT {43;}';
	eval 'sub ESOCKTNOSUPPORT {44;}';
	eval 'sub EOPNOTSUPP {45;}';
	eval 'sub EPFNOSUPPORT {46;}';
	eval 'sub EAFNOSUPPORT {47;}';
	eval 'sub EADDRINUSE {48;}';
	eval 'sub EADDRNOTAVAIL {49;}';
	eval 'sub ENETDOWN {50;}';
	eval 'sub ENETUNREACH {51;}';
	eval 'sub ENETRESET {52;}';
	eval 'sub ECONNABORTED {53;}';
	eval 'sub ECONNRESET {54;}';
	eval 'sub ENOBUFS {55;}';
	eval 'sub EISCONN {56;}';
	eval 'sub ENOTCONN {57;}';
	eval 'sub ESHUTDOWN {58;}';
	eval 'sub ETOOMANYREFS {59;}';
	eval 'sub ETIMEDOUT {60;}';
	eval 'sub ECONNREFUSED {61;}';
	eval 'sub ELOOP {62;}';
    }
    eval 'sub ENAMETOOLONG {63;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub EHOSTDOWN {64;}';
	eval 'sub EHOSTUNREACH {65;}';
    }
    eval 'sub ENOTEMPTY {66;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub EPROCLIM {67;}';
	eval 'sub EUSERS {68;}';
	eval 'sub EDQUOT {69;}';
	eval 'sub ESTALE {70;}';
	eval 'sub EREMOTE {71;}';
	eval 'sub EBADRPC {72;}';
	eval 'sub ERPCMISMATCH {73;}';
	eval 'sub EPROGUNAVAIL {74;}';
	eval 'sub EPROGMISMATCH {75;}';
	eval 'sub EPROCUNAVAIL {76;}';
    }
    eval 'sub ENOLCK {77;}';
    eval 'sub ENOSYS {78;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub EFTYPE {79;}';
	eval 'sub EAUTH {80;}';
	eval 'sub ENEEDAUTH {81;}';
	eval 'sub ELAST {81;}';
    }
    if (defined &KERNEL) {
	eval 'sub ERESTART {-1;}';
	eval 'sub EJUSTRETURN {-2;}';
    }
}
1;
