if (!defined &_SYS_STAT_H_) {
    eval 'sub _SYS_STAT_H_ {1;}';
    require 'sys/time.ph';
    if (!defined &_POSIX_SOURCE) {
    }
    eval 'sub st_atime {defined &st_atimespec && &st_atimespec.defined &ts_sec && &ts_sec;}';
    eval 'sub st_mtime {defined &st_mtimespec && &st_mtimespec.defined &ts_sec && &ts_sec;}';
    eval 'sub st_ctime {defined &st_ctimespec && &st_ctimespec.defined &ts_sec && &ts_sec;}';
    eval 'sub S_ISUID {0004000;}';
    eval 'sub S_ISGID {0002000;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub S_ISTXT {0001000;}';
    }
    eval 'sub S_IRWXU {0000700;}';
    eval 'sub S_IRUSR {0000400;}';
    eval 'sub S_IWUSR {0000200;}';
    eval 'sub S_IXUSR {0000100;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub S_IREAD {defined &S_IRUSR && &S_IRUSR;}';
	eval 'sub S_IWRITE {defined &S_IWUSR && &S_IWUSR;}';
	eval 'sub S_IEXEC {defined &S_IXUSR && &S_IXUSR;}';
    }
    eval 'sub S_IRWXG {0000070;}';
    eval 'sub S_IRGRP {0000040;}';
    eval 'sub S_IWGRP {0000020;}';
    eval 'sub S_IXGRP {0000010;}';
    eval 'sub S_IRWXO {0000007;}';
    eval 'sub S_IROTH {0000004;}';
    eval 'sub S_IWOTH {0000002;}';
    eval 'sub S_IXOTH {0000001;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub S_IFMT {0170000;}';
	eval 'sub S_IFIFO {0010000;}';
	eval 'sub S_IFCHR {0020000;}';
	eval 'sub S_IFDIR {0040000;}';
	eval 'sub S_IFBLK {0060000;}';
	eval 'sub S_IFREG {0100000;}';
	eval 'sub S_IFLNK {0120000;}';
	eval 'sub S_IFSOCK {0140000;}';
	eval 'sub S_ISVTX {0001000;}';
    }
    eval 'sub S_ISDIR {
        local($m) = @_;
        eval "((($m) & 0170000) == 0040000)";
    }';
    eval 'sub S_ISCHR {
        local($m) = @_;
        eval "((($m) & 0170000) == 0020000)";
    }';
    eval 'sub S_ISBLK {
        local($m) = @_;
        eval "((($m) & 0170000) == 0060000)";
    }';
    eval 'sub S_ISREG {
        local($m) = @_;
        eval "((($m) & 0170000) == 0100000)";
    }';
    eval 'sub S_ISFIFO {
        local($m) = @_;
        eval "((($m) & 0170000) == 0010000 || (($m) & 0170000) == 0140000)";
    }';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub S_ISLNK {
	    local($m) = @_;
	    eval "((($m) & 0170000) == 0120000)";
	}';
	eval 'sub S_ISSOCK {
	    local($m) = @_;
	    eval "((($m) & 0170000) == 0010000 || (($m) & 0170000) == 0140000)";
	}';
    }
    if (!defined &_POSIX_SOURCE) {
	eval 'sub ACCESSPERMS {(defined &S_IRWXU && &S_IRWXU|defined &S_IRWXG && &S_IRWXG|defined &S_IRWXO && &S_IRWXO);}';
	eval 'sub ALLPERMS {(defined &S_ISUID && &S_ISUID|defined &S_ISGID && &S_ISGID|defined &S_ISTXT && &S_ISTXT|defined &S_IRWXU && &S_IRWXU|defined &S_IRWXG && &S_IRWXG|defined &S_IRWXO && &S_IRWXO);}';
	eval 'sub DEFFILEMODE {(defined &S_IRUSR && &S_IRUSR|defined &S_IWUSR && &S_IWUSR|defined &S_IRGRP && &S_IRGRP|defined &S_IWGRP && &S_IWGRP|defined &S_IROTH && &S_IROTH|defined &S_IWOTH && &S_IWOTH);}';
	eval 'sub S_BLKSIZE {512;}';
	eval 'sub UF_SETTABLE {0x0000ffff;}';
	eval 'sub UF_NODUMP {0x00000001;}';
	eval 'sub UF_IMMUTABLE {0x00000002;}';
	eval 'sub UF_APPEND {0x00000004;}';
	eval 'sub SF_SETTABLE {0xffff0000;}';
	eval 'sub SF_ARCHIVED {0x00010000;}';
	eval 'sub SF_IMMUTABLE {0x00020000;}';
	eval 'sub SF_APPEND {0x00040000;}';
	if (defined &KERNEL) {
	    eval 'sub APPEND {(defined &UF_APPEND && &UF_APPEND | defined &SF_APPEND && &SF_APPEND);}';
	    eval 'sub IMMUTABLE {(defined &UF_IMMUTABLE && &UF_IMMUTABLE | defined &SF_IMMUTABLE && &SF_IMMUTABLE);}';
	}
    }
    if (defined &KERNEL) {
    }
    else {
	require 'sys/cdefs.ph';
	if (!defined &_POSIX_SOURCE) {
	}
    }
}
1;
